Subject: Re: [PATCH net-next v25 01/23] net: introduce OpenVPN Data Channel Offload (ovpn)

From: Jakub Kicinski <[email-masked]>
Date: Fri, 11 Apr 2025 14:18:47 -0700

On Fri, 11 Apr 2025 15:50:49 +0200 Sabrina Dubroca wrote:
> > My understanding is that this is the standard approach to:
> > 1) hook in the middle of registration/deregistration;
> > 2) handle events generated by other components/routines.
> > 
> > I see in /drivers/net/ almost every driver registers a notifier for their
> > own device.  
> 
> I think most of them register a notifier for their lower device
> (bridge port, real device under a vlan, or similar).
> 
> I've mentioned at some point that it would be more usual to replace
> this notifier with a custom dellink, and that ovpn->registered could
> likely be replaced with checking for NETREG_REGISTERED. I just thought
> it could be cleaned up a bit later, but it seems Jakub wants it done
> before taking the patches :)

Ideally, yes. One fewer place for us to check when trying to figure 
out if we will break anything with the locking changes :(
Notifiers are very powerful but that comes at high maintenance cost.